#include <stdio.h>
#include <string.h>

#include "lcomp/stubs.h"
#include "lcomp/ioctl.h"
#include "lcomp/e2010cmd.h"

#include "lcomp/ifc_ldev.h"
#include "ldevbase.h"
#include "e2010.h"

// размер не лезет.....
// универсально для 2010 и 2010b, но размер прошивок важен!!!!
FDF(ULONG) DaqE2010::LoadBios(const char *FileName) {
    CHAR  FName[512];
    FILE  *BiosFile;
    LONG    PLDSize,NBytes;
    PUCHAR  BiosCode=0;
    PUCHAR BC=0;
    ULONG cbRet;
    int status = L_ERROR;
    do
    {
        int internal_name = (FileName == NULL) ||
                (FileName[0]=='\0') ||
                (FileName[0]=='\n') ||
                (FileName[0]=='\r');

        if (internal_name) {
            strcpy(FName, LCOMP_INSTALL_FIRMWARE_DIR);
            strcat(FName, "/");
            if (sl.BoardType == E2010) {
                strcat(FName, "e2010");
            } else {
                /** @todo how to check if this is industrial board ? */
                strcat(FName, "e2010m");
            }
        } else {
            strncpy(FName, FileName, sizeof(FName) - 5);
        }
        strcat(FName,".pld");

        BiosFile=fopen(FName, "rb");
        if(!BiosFile) break;

        fseek(BiosFile,0,SEEK_END);
        PLDSize=NBytes = ftell(BiosFile);
        rewind(BiosFile);

        BC=BiosCode=new UCHAR[NBytes+2];
        if(BiosCode==NULL) break;
        if(fread(BiosCode,1,NBytes,BiosFile) != (size_t)NBytes) break;

        // transfer bios to driver
        int len = 4096;
        // first call alloc memory, other simple add data
        do
        {
            if(NBytes<len) len=NBytes;
            if(!LDeviceIoControl( hVxd, DIOC_SEND_BIOS,
                                  &NBytes,sizeof(LONG),
                                  BiosCode, len*sizeof(CHAR),
                                  &cbRet, NULL)) break;
            BiosCode+=len;
            NBytes-=len;
        } while(NBytes);
        if(NBytes) break; // not all transfered to driver

        // load prev transf. bios and free memory //////////////////////////////////////////////////////////////
        //NBytes = EP1K10_SIZE;
        if(!LDeviceIoControl( hVxd, DIOC_LOAD_BIOS,
                              &PLDSize,sizeof(LONG),
                              NULL, 0,
                              &cbRet, NULL)) break;
        status = L_SUCCESS; // all ok
    } while (status==L_ERROR);

    if(BC) delete[] BC;
    if(BiosFile) fclose(BiosFile);
    return status;//E;
}
